package h09;

import h09.abilities.Swims;
import h09.animals.Animal;
import h09.animals.Fish;
import h09.animals.Lion;
import h09.animals.Penguin;
import org.junit.jupiter.api.Test;
import org.tudalgo.algoutils.student.annotation.StudentImplementationRequired;

import static org.junit.jupiter.api.Assertions.*;

/**
 * An example JUnit test class.
 */
public class EnclosureTest {

    @Test
    @StudentImplementationRequired("H9.5.1")
    public void testForEach() {
        // TODO: H9.5.1
        Lion lia = new Lion("Lia", 1);
        Lion lib = new Lion("Lib", 1);
        Lion lic = new Lion("Lic", 1);

        // Creating lion enclosure...
        GroundEnclosure<Lion> lionEnclosure = new GroundEnclosure<>();
        lionEnclosure.getStack().push(lia);
        lionEnclosure.getStack().push(lib);
        lionEnclosure.getStack().push(lic);

        assertTrue(lia.isHungry());
        assertTrue(lib.isHungry());
        assertTrue(lic.isHungry());

        lionEnclosure.forEach(Lion::eat);

        assertFalse(lia.isHungry());
        assertFalse(lib.isHungry());
        assertFalse(lic.isHungry());
    }


    @Test
    @StudentImplementationRequired("H9.5.2")
    public void testFilter() {
        // TODO: H9.5.2
        // crating fish
        Penguin tux = new Penguin("tux", 1, -5);
        tux.eat();

        Penguin windoof = new Penguin("windoof", 1, -5);

        WaterEnclosure<Penguin> enclosure = new WaterEnclosure<>();
        enclosure.getStack().push(tux);
        enclosure.getStack().push(windoof);

        assertFalse(tux.isHungry());
        assertTrue(windoof.isHungry());

        enclosure
            .filterFunc(WaterEnclosure::new, Animal::isHungry)
            .filterFunc(WaterEnclosure::new, Enclosure.SWIMS_AT_LOW_ELEVATION)
            .forEach(Penguin::swimUp);

        assertTrue(tux.getElevation() < Swims.HIGH_ELEVATION);
        assertTrue(windoof.getElevation() > Swims.HIGH_ELEVATION);

        enclosure
            .filterFunc(WaterEnclosure::new, Animal::isHungry)
            .forEach(Enclosure.EAT_AND_SINK());

        assertTrue(tux.getElevation() < Swims.HIGH_ELEVATION);
        assertTrue(windoof.getElevation() < Swims.HIGH_ELEVATION);

        assertFalse(tux.isHungry());
        assertFalse(windoof.isHungry());
    }
}
